package level12;

import java.util.Iterator;

/**
 * A_CountOccurrences
 * 
 * Part of an inventory of problems to help students
 * assess their progress in Programming I and Programming II
 * at Wheaton College.
 * 
 * Level 12: Writing basic iterators.
 * Problem A: Array iterator.
 * 
 * Class to encapsulate iteration over an array. When given
 * a reference to an array by its constructor, an instance of
 * this class will return the elements of the array, in order,
 * from successive calls to the next() method.
 * 
 * @author Thomas VanDrunen
 * July 22, 2015
 */
public class A_ArrayIterator implements Iterator<Integer> {

    
    /**
     * Constructor.
     * @param array The array on which to iterate.
     */
    public A_ArrayIterator(int[] array) {

    }

    /**
     * Are there any more elements to return?
     */
    public boolean hasNext() {
    	return false;
    }

    /**
     * Return the next element in the iteration (ie, the
     * next element in the array).
     */
    public Integer next() {
    	return -1;
    }

    // ignore
    public void remove() {
        throw new UnsupportedOperationException();
    }

    // sample use
    // should print 5, 12, 13, 3, 4, 21 each on a separate line
    public static void main(String[] args) {

        int[] a = new int[] { 5, 12, 13, 3, 4, 21 };
        
        for (Iterator<Integer> it = new A_ArrayIterator(a); it.hasNext(); )
            System.out.println(it.next());

    }
}
