package level12;

import java.util.Iterator;

/**
 * A_CountOccurrences
 * 
 * Part of an inventory of problems to help students
 * assess their progress in Programming I and Programming II
 * at Wheaton College.
 * 
 * Level 12: Writing basic iterators.
 * Problem B: Linked list iterator.
 * 
 * Class to encapsulate iteration over a linked list. When given
 * a reference to a head node by its constructor, an instance of
 * this class will return the elements of the list headed by that node, 
 * in order, from successive calls to the next() method.
 * 
 * @author Thomas VanDrunen
 * July 22, 2015
 */
public class B_LinkedListIterator implements Iterator<Integer> {

    
    /**
     * Constructor.
     * @param head The head of the list on which to iterate.
     */
    public B_LinkedListIterator(Node head) {
    	
    }

    /**
     * Are there any more elements to return?
     */
   public boolean hasNext() {
	   return false;
   }

    /**
     * Return the next element in the iteration (ie, the
     * next element in the list).
     */
    public Integer next() {
    	return -1;
    }

    // ignore
    public void remove() {
        throw new UnsupportedOperationException();
    }

    // sample use
    // should print 5, 12, 13, 3, 4, 21 each on a separate line
    public static void main(String[] args) {

        Node h = new Node(5, new Node(12, new Node(13, new Node(3, new Node(4, new Node(12, null))))));
        
        for (Iterator<Integer> it = new B_LinkedListIterator(h); it.hasNext(); )
            System.out.println(it.next());

    }
}
