package level12;

import java.util.Iterator;

/**
 * C_RangeIterator
 * 
 * Part of an inventory of problems to help students
 * assess their progress in Programming I and Programming II
 * at Wheaton College.
 * 
 * Level 12: Writing basic iterators.
 * Problem C: Range iterator.
 * 
 * Class to encapsulate iteration over a range. When given a 
 * starting value and a stopping value (and, optionally, a skip
 * amount) by its constructor, an instance of this class will
 * return the values between the starting value, inclusive, and
 * the ending value, exclusive (optionally by increments of the
 * skip amount).
 * 
 * @author Thomas VanDrunen
 * July 22, 2015
 */
public class C_RangeIterator implements Iterator<Integer> {

    
    /**
     * Constructor for a range incremented by a skip amount.
     * @param start The starting value, inclusive
     * @param stop The stopping value, exclusive
     * @param skip The amount successive values are to increase, 
     * assumed positive.
     */
    public C_RangeIterator(int start, int stop, int skip) {

    }

    /**
     * Constructed for a straight range.
     * @param start The starting value, inclusive
     * @param stop The stopping value, exclusive
     */
    public C_RangeIterator(int start, int stop) {

    }
    
    /**
     * Are there any more elements to return?
     */
    public boolean hasNext() {
    	return false;
    }

    /**
     * Return the next element in the iteration (ie, the
     * next element in the range).
     */
    public Integer next() {
    	return -1;
    }

    // ignore
    public void remove() {
        throw new UnsupportedOperationException();
    }

    // sample use
    // should print -3, -2, -1, 0, 1, 2, 3, 4, 5 each on a separate line,
    // followed by 6, 13, 20, 27, 34
    public static void main(String[] args) {

        for (Iterator<Integer> it = new C_RangeIterator(-3, 6); it.hasNext(); )
            System.out.println(it.next());

        for (Iterator<Integer> it = new C_RangeIterator(6, 39, 7); it.hasNext(); )
            System.out.println(it.next());
   }
   
    
}
