package level12;

/**
 * Node
 * 
 * Part of an inventory of problems to help students
 * assess their progress in Programming I and Programming II
 * at Wheaton College.
 * 
 * Level 5: Linked lists, basic iterative algorithms
 * Auxiliary class representing nodes in the linked list.
 * 
 * @author Thomas VanDrunen
 * July 21, 2015
 */
public class Node {

    /**
     * Value stored at this node
     */
    private int datum;

    /**
     * The node that comes after this one, or null
     * if none
     */
    private Node next;

    /**
     * Basic constructor
     */
    public Node(int datum, Node next) {
        this.datum = datum;
        this.next = next;
    }

    /**
     * Getter for the datum stored here
     * @return The value stored at this node
     */
    public int getDatum() { return datum; }

    /**
     * Getter for the next node,
     * @return The node that follows this one or null if none
     */
    public Node getNext() { return next; }

    /**
     * Setter for the next link
     * @param next The node which shall now follow this one.
     * POSTCONDITION: This node's next link now refers to the
     * given node.
     */
    public void setNext(Node next) { this.next = next; }

}
